<template>
    <div ref="scrollContainer" class="scroll-container w-100">
      <!-- Pull to refresh -->
      <PullToRefresh ref="pullRefresh" :container="scrollContainer" @refresh="fetchData"></PullToRefresh>
      
      <!-- Page content -->
      <div class="container mx-auto p-5 mb-12">
        <!-- Page title -->
        <PageTitle title="Conditions" />

        <Alert v-if="showError" type="error" title="Error" :body="errorText" />

        <!-- List of conditions -->
        <GenericWidget v-for="item in list"
          :itemId="item.id"
          :itemName="item.name"
          :itemActorType="item.actorType"
          :itemActorName="item.actorName"
          :itemActorId="item.actorId"
          :itemOperator="item.operator"
          :itemValue1="item.value1"
          :itemValue2="item.value2"
          itemType="condition"
          @editEvent="openEditModal" 
          @deleteEvent="openDeleteModal"
        ></GenericWidget>
      </div>
      
      <!-- Modal -->
      <Modal id="condition" :modalData="modalData" @onSubmit="handleSubmit" @closeModal="closeModal" />

      <!-- Add Create Condition button -->
      <FloatingActionButton @click="openCreateModal" />
    </div>
</template>

<script>
    import GenericWidget from '@/components/GenericWidget.vue';
    import PullToRefresh from '@/components/PullToRefresh.vue';
    import PageTitle from '@/components/PageTitle.vue';
    import FloatingActionButton from '@/components/FloatingActionButton.vue';
    import Modal from '@/components/Modal.vue';
    import Alert from '@/components/Alert.vue';

    let ACTORS = [];
    const OPERATORS = [
        {
            text: "Equal to",
            value: "=="
        },
        {
            text: "Not equal to",
            value: "!="
        },
        {
            text: "Minor or equal than",
            value: "<="
        },
        {
            text: "Grater or equal than",
            value: ">="
        },
        {
            text: "Minor than",
            value: "<"
        },
        {
            text: "Greater than",
            value: ">"
        },
        {
            text: "Between two values",
            value: "between"
        },
        {
            text: "Not between two values",
            value: "not between"
        }
    ]
    
    export default {
        props: {
            activityId: { type: String, required: true },
        },
        components: {   
            GenericWidget,
            PullToRefresh,
            PageTitle,
            FloatingActionButton,
            Modal,
            Alert
        },
        data() {
            return {
                list: [], // array of items
                devices: [],
                scrollContainer: {}, // useful element for pull-to-refresh

                // props for modal component...
                modalData: {},
                showError: false,
            };
        },
        mounted() {
            // prepare the pull-to-refresh
            this.scrollContainer = this.$refs.scrollContainer
            this.$refs.pullRefresh.init()
            
            // Access activityId from the route parameters
            const activityId = parseInt(this.$route.params.activityId);
            this.fetchDevices();
        },
        methods: {
            fetchDevices() {
                // Fetching the list of devices
                var self = this;
                self.$axios.get(`/devices`)
                .then(function (response) {
                    // handle success
                    self.showError = false
                    // Format the devices list
                    self.devices = response.data.map(device => ({
                        text: device.name,
                        value: device.id
                    }));

                    ACTORS = self.devices
                    ACTORS.unshift({text: "System Timestamp", value: "timestamp"})

                    self.fetchData();
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.errorText = 'Devices not found, connect some devices first!';
                });
                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)
            },
            fetchData() {
                // Fetching the list of routines
                var self = this;
                self.$axios.get(`activities/${this.activityId}/conditions`)
                .then(function (response) {
                    // handle success
                    self.showError = false
                    // add the device name
                    response.data.forEach(d => {
                        let actName = self.devices.find(de => de.value == (d.actorId != null ? d.actorId : "timestamp"))
                        d.actorName = actName ? actName.text : null
                    })
                    console.log("Conditions LIST:")
                    console.log(self.list);
                    self.list = response.data;
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.errorText = error;
                });
                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            create(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()
                var self = this;
                self.$axios.post(`activities/${this.activityId}/conditions`, {
                    name: item.conditionName,
                    actorId: (item.actorId === "timestamp") ? null : item.actorId,
                    actorType: (item.actorId !== 'timestamp') ? 'sensor' : 'timestamp',
                    operator: item.operator,
                    value1: item.value1,
                    value2: item.value2,
                    activityId: this.activityId
                })
                .then(async (response) => {
                    // handle success
                    self.fetchData();
                    self.$toast.success("Condition created successfully!");
                })
                .catch(function (error) {
                    // handle error
                    console.log(error);
                    self.showError = true;
                    self.$toast.error(error.response.data.message);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            edit(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()
                
                console.log(item);
                // TODO: PUT /routines
                var self = this;
                self.$axios.put(`activities/${this.activityId}/conditions`, {
                    id: item.conditionId,
                    name: item.conditionName,
                    actorId: (item.actorId === "timestamp") ? null : item.actorId,
                    actorType: (item.actorId !== 'timestamp') ? 'sensor' : 'timestamp',
                    operator: item.operator,
                    value1: item.value1,
                    value2: item.value2,
                    activityId: this.activityId // TODO: serve?
                })
                .then(async (response) => {
                    // handle success
                    this.fetchData();
                    self.$toast.success("Condition updated successfully!");
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.$toast.error(error);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            remove(item) {
                if (this.$refs.pullRefresh.isPulling || this.$refs.pullRefresh.isRefreshing) {
                    return
                }
                this.$refs.pullRefresh.stopPull()

                var self = this;
                self.$axios.delete(`activities/${this.activityId}/conditions`, {
                    data: {
                        id: item.conditionId
                    }
                })
                .then(async (response) => {
                    // handle success
                    this.fetchData();
                    self.$toast.success("Condition deleted successfully!");
                })
                .catch(function (error) {
                    // handle error
                    self.showError = true;
                    self.$toast.error(error.response.data.message);
                });

                setTimeout(() => {
                    this.$refs.pullRefresh.refreshSuccess()
                }, 1000)

                this.closeModal();
            },
            /*toggleStatus(newData) {
                console.log(newData)
                // TODO: PUT /routines
                var self = this;
                self.$axios.put('/activities', newData)
                .then(async function (response) {
                    // handle success
                    self.$toast.success("Status updated successfully!");
                }).catch(function (error) {
                    self.$toast.error(error.response.data.message);
                });
            },*/
            openCreateModal() {
                this.modalData = {
                    id: "createCondition",
                    title: "Create Condition",
                    text: "Fill all the fields in this form to create a new condition related to an activity.",
                    fields: [
                        {
                            label: 'Name',
                            type: 'input',
                            placeholder: 'Condition Name (e.g. Time if it concerns time periods)',
                            value: '',
                            required: true,
                            id: 'conditionName',
                        },
                        {
                            label: 'Actor',
                            type: 'select_textual',
                            placeholder: 'Actor',
                            value: '-1',
                            required: true,
                            id: 'actorId',
                            items: ACTORS
                        },
                        {
                            label: 'Logic operator to satisfy the condition between the first and second value (if any)',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'operator',
                            value: '-1',
                            items: OPERATORS
                        },
                        {
                            label: 'First Value',
                            type: 'input',
                            placeholder: 'Value 1',
                            required: true,                            
                            value: "",
                            id: 'value1'
                        },
                        {
                            label: 'Second Value',
                            type: 'input',
                            placeholder: 'Value 2',
                            required: false,                            
                            value: "",
                            id: 'value2'
                        },
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "create"
                }
                // opens the (creation) form
                condition.showModal()
            },
            openEditModal(item) {
                // forms for item deletion
                this.modalData = {
                    id: "editCondition",
                    title: "Edit Condition",
                    text: "Change the fields you want to edit and click confirm to save the changes.",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.itemId,
                            required: true,
                            id: 'conditionId',
                        },
                        {
                            label: 'Name',
                            type: 'input',
                            placeholder: 'Condition Name (e.g. Time if it concerns time periods)',
                            value: item.itemName,
                            required: true,
                            id: 'conditionName',
                        },
                        {
                            label: 'Actor',
                            type: 'select_textual',
                            placeholder: 'Actor',
                            value: (item.itemActorId !== null) ? item.itemActorId : 'timestamp',
                            required: true,
                            id: 'actorId',
                            items: ACTORS
                        },
                        {
                            label: 'Logic operator to satisfy the condition between the first and second value (if any)',
                            type: 'select_textual',
                            placeholder: '',
                            required: true,
                            id: 'operator',
                            value: item.itemOperator,
                            items: OPERATORS
                        },
                        {
                            label: 'First Value',
                            type: 'input',
                            placeholder: 'Value 1',
                            required: true,                            
                            value: item.itemValue1,
                            id: 'value1'
                        },
                        {
                            label: 'Second Value',
                            type: 'input',
                            placeholder: 'Value 2',
                            required: false,                            
                            value: item.itemValue2,
                            id: 'value2'
                        },  
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "edit"
                };
                condition.showModal();
            },
            openDeleteModal(item) {
                // forms for item deletion
                this.modalData = {
                    id: "deleteCondition",
                    title: "Delete Condition",
                    text: "Are you sure you want to delete this condition?",
                    fields: [
                        {
                            label: '',
                            type: 'hidden',
                            value: item.itemId,
                            required: true,
                            id: 'conditionId',
                        }
                    ],
                    buttons: [
                        { text: "Close", cssClass: "", onClick: "closeModal", type: "button", enabled: true },
                        { text: "Confirm", cssClass: "btn-primary", type: "submit", enabled: true, onClick: "" }
                    ],
                    onSubmit: "remove"
                };
                condition.showModal();
            },
            closeModal() {
                condition.close()
            },
            handleSubmit(data){
                this[this.modalData.onSubmit](data)
            },
            goBack() {
                this.$router.go(-1);
            }
        }
    }
</script>